function [A,beta,V]=HESSENBERG(A)
% [H,beta]=HESSENBERG(A)
% alternativer Aufruf:
% [H,beta,V]=HESSENBERG(A)
%
% Transformiere A mittels Householder-Transformationen auf obere Hessenbergform, 
% H=V'*A*V.
% Die Werte der Householder-Transformation werden im strikten unteren Dreieck
% von H gespeichert, sofern V nicht gesucht ist. Ansonsten enthlt V die
% Transformation.
% 
% -----------------------------------------------------------------------------
%
% Input
% -----
% A       nxn Matrix
%
% -----------------------------------------------------------------------------
%
% Output
% ------
% H       nxn obere Hessenbergmatrix, A wird mit dem Wert der Hessenbergmatrix
%         berschrieben. Das strikte untere Dreieck von H enthlt die Vektoren
%         der Householdertransformationen, sofern V nicht explizit erwnscht
%         ist
% beta    Parametervektor fr die Householdertransformation
% V       optional, Transformationsmatrix

n=size(A,1);
if nargout==3
   V=eye(n);
end % if



% Ab hier Hessenbergreduktion.

% Optionale Berechnung der Transformationsmatrix V in 
% Abhngigkeit von 'nargout'
%
%    if nargout==3
%       Aufdatierung V ...
%    end % if-else
