addpath('../routines/');
addpath('../examples/');

strg{1}='Hessenberg-Reduktion OHNE Transformationsmatrix';
strg{2}='`hess` aus MATLAB OHNE Transformationsmatrix';
strg{3}='Hessenberg-Reduktion mit Transformationsmatrix';
strg{4}='`hess` aus MATLAB mit Transformationsmatrix';
strg{5}='Vergleich aller';
strg{6}='ENDE';



% Anzahl Testmatrizen pro Dimension
anz=5;
v=10:10:100;

method=0;
method=menu('Welches Verfahren?',strg);
if method==6
   return
end
fprintf('%s\n',strg{method})
while method<6


      clear legendtxt1 legendtxt2
      i=1;
      if method==1 | method==5
	 legendtxt1{i}='Hessenbg. o. Transf.';
	 i=i+1;
      end 
      if method==2 | method==5
	 legendtxt1{i}='`hess` aus MATLAB o. Transf.';
      end 
      i=1;
      if method==3 | method==5
	 legendtxt2{i}='Hessenbg. m. Transf.';
	 i=i+1;
      end 
      if method==4 | method==5
	 legendtxt2{i}='`hess` aus MATLAB m. Transf.';
      end 
      fl=zeros(4,length(v));
      fehler=zeros(2,length(v));
      j=1;
      fprintf(' n |     Zeit ohne V     |     Zeit mit V      | Fehler der Zerlegung\n');
      fprintf('   |HESSENBERG|   hess   |HESSENBERG|   hess   |HESSENBERG|   hess   \n');
      fprintf('---------------------------------------------------------------------\n');
      
      for n=v
	 for i=1:anz
	    A=randn(n)-.5;
	    
	    if method==1 | method==5
	       % Hessenbergreduktion, ohne V
	       t0 = clock;
	       [H1,beta]=HESSENBERG(A);
	       fl(1,j)=fl(1,j)+etime(clock,t0); 
	    end
	    
	    if method==2 | method==5
	       t0 = clock;
	       H2=hess(A);
	       fl(2,j)=fl(2,j)+etime(clock,t0); 
	    end
	
	    if method==3 | method==5
	       % Hessenbergreduktion, mit V
	       t0 = clock;
	       [H1,beta,V1]=HESSENBERG(A);
	       fl(3,j)=fl(3,j)+etime(clock,t0); 
	       fehler(1,j)=fehler(1,j)+norm(V1*triu(H1,-1)*V1'-A,1);
	    end
	    
	    if method==4 | method==5
	       t0 = clock;
	       [V2,H2]=hess(A);
	       fl(4,j)=fl(4,j)+etime(clock,t0); 
	       fehler(2,j)=fehler(2,j)+norm(V2*H2*V2'-A,1);
	    end
	    
	 end % for i

	 fl(:,j)=fl(:,j)/anz;
	 fehler(:,j)=fehler(:,j)/anz;
	 fprintf('%3d| %8.1e | %8.1e | %8.1e | %8.1e | %8.1e | %8.1e\n',n,...
	     fl(1,j),fl(2,j),fl(3,j),fl(4,j),fehler(1,j),fehler(2,j));
	 j=j+1;
      end % for n

      figure(1);
      clf
      if method<=2 | method==5
	 if method==1 | method==5
	    loglog(v, fl(1,:), '+r');
	    hold on
	 end
	 if method==2 | method==5
	    loglog(v, fl(2,:),'og');
	 end
	 hold off
	 title('Rechenzeit Hessenbergreduktion OHNE Transf.');
	 xlabel('n');
	 ylabel('Zeit [sec]');
	 legend(legendtxt1)
      end
      
      figure(3);
      clf
      figure(2);
      clf
      if method>=3
	 if method==3 | method==5
	    loglog(v, fl(3,:), '+r');
	    hold on
	 end
	 if method==4 | method==5
	    loglog(v, fl(4,:),'og');
	 end
	 hold off
	 title('Rechenzeit Hessenbergreduktion MIT Transf.');
	 xlabel('n');
	 ylabel('Zeit [sec]');
	 legend(legendtxt2)
	 figure(3);
	 clf
	 if method==3 | method==5
	    semilogx(v, fehler(1,:),'+r');
	    hold on
	 end
	 if method==4 | method==5
	    semilogx(v, fehler(2,:),'og');
	 end
	 hold off
	 title('Genauigkeit Hessenbergreduktion');
	 xlabel('n');
	 ylabel('gemittelter Fehler');
	 legend(legendtxt2)
      end
      
      method=menu('Welches Verfahren?',strg);
      if method==6
	 return
      end
      fprintf('%s\n',strg{method})

end % while
      